unit RubyFind_DIR;
// Procedura per la ricerca di una directory che lavora come
// cerca/trova di windows.
// Questa particolare funzione dovrebbe essere di aiuto ad Alvise
// BY DelphiRuby: www.delphiruby.com
// delphiruby@gmail.com
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;
type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Edit1: TEdit;
    Label1: TLabel;
    Memo1: TMemo;
    Bevel1: TBevel;
    procedure BitBtn1Click(Sender: TObject);
  private
   Procedure DelphirubyDIR(mask: string);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  PATH_Temporaneo, Stringa :String;
  Temp : Tstrings;

implementation

{$R *.dfm}
Procedure TForm1.DelphirubyDIR(mask: string);
 var
  I: Integer;
  TrovaDIR: TSearchRec;
  Nuovadirectory:String;
 begin
  Nuovadirectory := ExtractFilePath(mask);
  I := Length(Stringa);
  while I > 0 do
   begin
    Stringa[I] := UpCase(Stringa[I]);
    I := I - 1;
   end;
  if Stringa = edit1.text then memo1.Lines.Add(Nuovadirectory);
  if FindFirst(Nuovadirectory + '*.*', $3F, TrovaDIR) = 0 then
  begin repeat
   if ((TrovaDIR.Attr and faDirectory) = faDirectory) and (TrovaDIR.Name[1] <> '.') then
    begin
     Stringa := TrovaDIR.Name;
     DelphirubyDIR(Nuovadirectory + TrovaDIR.Name + '\' + ExtractFileName(mask));
    end;
     until FindNext(TrovaDIR) <> 0;
    FindClose(TrovaDIR);
 end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var 
  disco, mask: string;
 begin
  memo1.Clear;
  temp:= TStringList.Create;
     disco := 'C:\';    // Inserire il disco dove effettuare la ricerca
     mask := '*.*';     // oppure creare un ciclo for-next per analizzare
      try               // tutti i dischi presenti nel PC.
       case GetDriveType(PChar(disco)) of
        DRIVE_FIXED, DRIVE_REMOTE, DRIVE_REMOVABLE:
        DelphirubyDIR(disco + mask);
       end;
      finally
    end;
 Temp.Free;
 showmessage('Ricerca conclusa.');
 end;
end.
